Debian Bug report logs - #688251
Built-Using description too aggressive

Package: debian-policy; Maintainer for debian-policy is Debian Policy List <debian-policy@lists.debian.org>; Source for debian-policy is src:debian-policy.

Reported by: Russ Allbery <rra@debian.org>

Date: Thu, 20 Sep 2012 18:03:04 UTC

Severity: normal

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Thu, 20 Sep 2012 18:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Thu, 20 Sep 2012 18:03:07 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Built-Using description too aggressive
Date: Thu, 20 Sep 2012 11:02:13 -0700
Package: debian-policy
Severity: normal

Based on discussion in debian-devel, the current Built-Using description
would imply that it had to be present for, say, the code from libgcc
incorporated into every binary build.  The description should be modified
to be clear that it is only mandatory if there are licensing reasons why
we have to be aware of the original source.

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 3.2.0-3-686-pae (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Sat, 29 Sep 2012 17:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sat, 29 Sep 2012 17:03:05 GMT) Full text and rfc822 format available.

Message #10 received at 688251@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: 689062@bugs.debian.org, Joey Hess <joeyh@debian.org>, Guillem Jover <guillem@debian.org>, 688251@bugs.debian.org
Subject: Re: dpkg-dev: Need to add support for Built-Using to dpkg-shlibdeps or new similar tool
Date: Sat, 29 Sep 2012 10:04:16 -0700
Hi,

Nicholas Bamber wrote:

> 	Sorry yes I did not mean to imply that there was a copyright issue
> with the inclusion of debhelper fragments in maintenance scripts, just
> an example of techincally it might happen. The policy explicitly
> mentions "incorporating source code".

Based on <http://bugs.debian.org/688251>, it seems there is some
belief that the policy wording here is broken.  I'm inclined to agree
with that --- it would be lovely to have a table of what binary
packages incorporate code from what source packages to help with
binnmus when there is an important fix, but that would be a pain to
maintain and wasn't the purpose of the Built-Using field that caused
a consensus to form around adding it to policy.

For reference, the current wording is:

	Some binary packages incorporate parts of other packages when
	built but do not have to depend on those packages. Examples
	include linking with static libraries or incorporating source
	code from another package during the build. In this case, the
	source packages of those other packages are a required part of
	the complete source (the binary package is not reproducible
	without them).

	A Built-Using field must list the corresponding source package
	for any such binary package incorporated during the build

I suspect some mention of license requirements or a threshold of
substantial amounts of code copied would help.

[...]
> For a more copyright-heavy example, see how "handlersocket" is  built
> using mysql-source-5.5.

Yes, that is a more typical case where Built-Using is intended to be
useful.

In pseudocode, something like this should work:

	built_using=

	for package in Build-Depends:
		if package name does not match the pattern *-source-*:
			continue
		pkgname=$(dpkg-query -W -f='${source:Package}' $package)
		pkgver=$(dpkg-query -W -f='${source:Version}' $package)
		built_using=${built_using+$built_using, }$pkgname" (= $pkgver)"

	...
	dpkg-genchanges -Vbuilddeps:Built-Using="$built_using" ...

This mechanism should be very useful for some use cases such as safely
adding cross-compilers (which build-depend and incorporate code from
gcc-source) to the archive.

Hoping that clarifies,
Jonathan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Thu, 12 Sep 2013 00:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to 688251@bugs.debian.org:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Thu, 12 Sep 2013 00:00:04 GMT) Full text and rfc822 format available.

Message #15 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: debian-devel@lists.debian.org, 688251@bugs.debian.org, ftpmaster@debian.org
Subject: Re: #688251: Built-Using description too aggressive
Date: Thu, 12 Sep 2013 08:57:34 +0900
Dear all,

there has been discussions about the Built-Using field and the way
it is currently documented in the Policy.  I think that there are
a short and a long term issue.

  - In the short term, we can correct the wording to match the FTP
    team's current practice, and reduce the confusion introduced by
    the Policy.

  - In the long term, somebody should step up and investigate whether
    Debian (and other distributions) does benefit or not from the license
    exceptions in the libc, GCC and similar packages, which would imply
    either a lot of extra work for us, or a correction of the license
    terms upstream (which may want to help us focusing on good work).

Here three quotations from earlier discussions.

Le Sat, Sep 29, 2012 at 10:04:16AM -0700, Jonathan Nieder a écrit :
> 
> For reference, the current wording is:
> 
> 	Some binary packages incorporate parts of other packages when
> 	built but do not have to depend on those packages. Examples
> 	include linking with static libraries or incorporating source
> 	code from another package during the build. In this case, the
> 	source packages of those other packages are a required part of
> 	the complete source (the binary package is not reproducible
> 	without them).
> 
> 	A Built-Using field must list the corresponding source package
> 	for any such binary package incorporated during the build
> 
> I suspect some mention of license requirements or a threshold of
> substantial amounts of code copied would help.

    http://lists.debian.org/20120929170416.GB164@mannheim-rule.local


Le Thu, Jan 31, 2013 at 11:41:40PM +0100, Matthias Klose a écrit :
> 
>  - footnote 58 in policy 7.8 says "The archive software might reject
>    packages that refer to non-existent sources". However they are also
>    manually rejected. And it looks like others aren't aware of this too.
> 
>  - The scope of what belongs into Built-Using is not clear. Policy is
>    vague ("Examples include ...") and ftp-master seems to have a much
>    more narrow interpretation.
> 
>    If "linking with static libraries" (and "object files" is missing here)
>    is what you want, then nearly every package having an executable
>    should have a Built-Using: eglibc. Every binary or shared library
>    linking with -lgcc (libgcc.a) should have a Built-Using: gcc-4.x.
>    Same for clang and probably most other compilers.
>    Is this wanted?
>    What is the value having this?

    http://lists.debian.org/87li75mo5b.fsf@windlord.stanford.edu


Le Thu, May 23, 2013 at 01:34:08PM -0700, Russ Allbery a écrit :
> 
> In a discussion of mksh-static (see http://bugs.debian.org/709382), the
> question of GPL compliance for the source code of the components of libgcc
> and libc that are incorporated into binaries came up.  mksh-static of
> course links statically and therefore pulls in substantial portions of
> library source, but there are parts of libgcc and possibly libc that are
> always incorporated into binaries, even ones that are dynamically linked.
> 
> I had previously assumed that this did not impose any restrictions on
> source code availability for the libgcc and libc source because they both
> have run-time exceptions that basically allow one to incorporate that code
> into binaries under any other license without following the terms of the
> GPL or LGPL.  However, Thorsten has raised the interesting point that the
> license of the source code for the binary may be GPL with no exceptions,
> and therefore under the GPL the resulting compiled executable is covered
> by the GPL and we have to provide its complete source code.  That would
> seem to include the source for the incorporated static libgcc and libc
> components, since Debian cannot make use of the operating system component
> exception in the GPL.
> 
> Obviously, I don't think anyone does this, and we've never done it
> historically.  But "no one does this" isn't the most compelling argument
> when it comes to license compliance.

    http://lists.debian.org/87li75mo5b.fsf@windlord.stanford.edu


I would like to make the short-term clarification for the next revision of the
Policy.  In its simplest form, it could be the addition of something like "when
the combination of licenses requires to keep all the sources", plus a footnote
informing that the case of the libc and libgcc are being investigated, and that
the current practice is to consider that we can benefit form their exception to
the GPL.

Please let us know your thoughts and suggestions by replying to
688251@bugs.debian.org. 

Have a nice day,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 03:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Charles Plessy <plessy@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 03:36:04 GMT) Full text and rfc822 format available.

Message #20 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: 688251@bugs.debian.org
Cc: debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 12:33:50 +0900
[Message part 1 (text/plain, inline)]
tag 688251 patch
thanks

Le Thu, Sep 12, 2013 at 08:57:34AM +0900, Charles Plessy a écrit :
> 
> I would like to make the short-term clarification for the next revision of the
> Policy.  In its simplest form, it could be the addition of something like "when
> the combination of licenses requires to keep all the sources", plus a footnote
> informing that the case of the libc and libgcc are being investigated, and that
> the current practice is to consider that we can benefit form their exception to
> the GPL.

Dear all,

do you think that the attached patch would solve the problem ?

Have a nice day,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan
[0001-Policy-underline-that-Built-Using-is-only-to-be-used.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 04:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 04:00:04 GMT) Full text and rfc822 format available.

Message #25 received at 688251@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Charles Plessy <plessy@debian.org>
Cc: 688251@bugs.debian.org, debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Built-Using description too aggressive
Date: Sun, 22 Sep 2013 20:56:38 -0700
Hi,

Charles Plessy wrote:

> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -5563,7 +5563,13 @@ Replaces: mail-transport-agent
>  	</p>
>  
>  	<p>
> -	  A <tt>Built-Using</tt> field must list the corresponding source
> +	  When the licensing terms of the incorporated parts require to provide
> +	  their source <footnote>
> +	  </footnote>,
> +	  a <tt>Built-Using</tt> field must list the corresponding source
>  	  package for any such binary package incorporated during the build

The above looks sensible.  As a small nit, it's not just the licensing
terms of the incorporated parts --- for example, if the incorporated
part were public domain but the code incorporating it had terms
requiring all corresponding source to be included with binaries,
it would probably still be wise to use Built-Using.

How about something like "When the license terms of a binary package
require providing the corresponding source incorporated from other
packages, [...]"?

> +	    As of September 2013, the current practice in Debian is to consider
> +	    that we can benefit from the GPL exceptions for the libc, GCC and
> +	    similar packages.

I can't agree with the above paragraph, mostly because I don't
understand it completely.  What GPL exception?

I am convinced it is legally fine to distribute a binary package of
Git because there is not a substantial amount of GPLv2-incompatible
code in the binary.  GCC's runtime exception doesn't help with that
at all, unfortunately (a GPLv2-incompatible license + GCC runtime
exception is still GPLv2-incompatible), but fortunately there is not
much GCC runtime code in the binary.

Of course that is only my own understanding, I am not an ftpmaster,
I am not a lawyer, etc etc.

Besides, this "As of September 2013" statement in policy feels quite
strange.

Would it be okay to leave out the footnote, or to say something more
practical like the following?

	<footnote>
	  <p>
	    For example, a cross-compiler package which Build-Depends on
	    gcc-5.2-source and whose source package consists of build rules
	    instead of compiler code should use "Built-Using: gcc-5.2
	    (= <version>)" to ensure the archive includes the corresponding
	    source for the produced binary.
	  </p>

	  <p>
	    Most packages do not need to use Built-Using, since the archive
	    maintenance tools already normally ensure that source for at least
	    one version of their build-time dependencies is present.
	  </p>
	</footnote>

Hope that helps,
Jonathan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 09:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 09:00:04 GMT) Full text and rfc822 format available.

Message #30 received at 688251@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
Cc: 688251@bugs.debian.org, debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 10:56:28 +0200
On Mon, Sep 23, 2013 at 5:33 AM, Charles Plessy wrote:

> do you think that the attached patch would solve the problem ?

There are more reasons for using Built-Using than licenses, for example:

Rebuilding against updated versions of static libraries.
Rebuilding the debian-installer-*-netboot-* packages.

I don't think we should restrict usage of Built-Using to only
license-related reasons, there are also other reasons.

-- 
bye,
pabs

http://wiki.debian.org/PaulWise



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 09:09:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Charles Plessy <plessy@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 09:09:09 GMT) Full text and rfc822 format available.

Message #35 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: debian-devel@lists.debian.org, 688251@bugs.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 18:04:56 +0900
Le Mon, Sep 23, 2013 at 10:56:28AM +0200, Paul Wise a écrit :
> On Mon, Sep 23, 2013 at 5:33 AM, Charles Plessy wrote:
> 
> > do you think that the attached patch would solve the problem ?
> 
> There are more reasons for using Built-Using than licenses, for example:
> 
> Rebuilding against updated versions of static libraries.
> Rebuilding the debian-installer-*-netboot-* packages.
> 
> I don't think we should restrict usage of Built-Using to only
> license-related reasons, there are also other reasons.

Hi Paul,

I agree.

The problem to solve here is to find a clear and concise way to describe how
this field is used.  The current description in the Policy has confused some
people and made them think or worry that they were asked unreasonable work.

I paste below the current wording in the Policy 3.9.4.  If you have an
improvement to propose, that would be much appreciated !

    7.8 Additional source packages used to build the binary - Built-Using
    
    Some binary packages incorporate parts of other packages when built but do not
    have to depend on those packages. Examples include linking with static
    libraries or incorporating source code from another package during the build.
    In this case, the source packages of those other packages are a required part
    of the complete source (the binary package is not reproducible without them).
    
    A Built-Using field must list the corresponding source package for any such
    binary package incorporated during the build [56], including an "exactly equal"
    ("=") version relation on the version that was used to build that binary
    package[57].
    
    A package using the source code from the gcc-4.6-source binary package built
    from the gcc-4.6 source package would have this field in its control file:
    
         Built-Using: gcc-4.6 (= 4.6.0-11)
    
    A package including binaries from grub2 and loadlin would have this field in
    its control file:
    
         Built-Using: grub2 (= 1.99-9), loadlin (= 1.6e-1)

Cheers,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 09:24:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 09:24:04 GMT) Full text and rfc822 format available.

Message #40 received at 688251@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: debian-devel@lists.debian.org
Cc: 688251@bugs.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 11:21:46 +0200
On Mon, Sep 23, 2013 at 11:04 AM, Charles Plessy wrote:

> I paste below the current wording in the Policy 3.9.4.  If you have an
> improvement to propose, that would be much appreciated !

The wording doesn't appear confusing to me so I'm not the best person
to propose wording changes.

> The problem to solve here is to find a clear and concise way to describe how
> this field is used.  The current description in the Policy has confused some
> people and made them think or worry that they were asked unreasonable work.

I would suggest leaving the current wording, monitoring usage of the
field and filing bugs on any packages that use the field in an
"improper" way.

-- 
bye,
pabs

http://wiki.debian.org/PaulWise



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 13:48:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ansgar Burchardt <ansgar@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 13:48:12 GMT) Full text and rfc822 format available.

Message #45 received at 688251@bugs.debian.org (full text, mbox):

From: Ansgar Burchardt <ansgar@debian.org>
To: 688251@bugs.debian.org
Cc: debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 15:45:42 +0200
On 09/23/2013 10:56, Paul Wise wrote:
> On Mon, Sep 23, 2013 at 5:33 AM, Charles Plessy wrote:
>> do you think that the attached patch would solve the problem ?
> 
> There are more reasons for using Built-Using than licenses, for example:
> 
> Rebuilding against updated versions of static libraries.
> Rebuilding the debian-installer-*-netboot-* packages.
> 
> I don't think we should restrict usage of Built-Using to only
> license-related reasons, there are also other reasons.

Yes, licensing isn't the only reason: if there was a clang-avr package
build-depending on clang-source (or gcc-avr built using a gcc relicensed
under a non-copyleft license), the source for the clang-avr package
should still be kept around and this would include the clang-source package.

In the end the problem comes down to defining what the "source" of a
binary package is. I doubt there are disagreements that the source for a
package X build-depending on Y-source includes Y-source or src:Y as in
the example above. In general I would also include statically linked
libraries. However I wouldn't think that language runtimes that are
added automatically by the compiler are part of the source of a binary.

There's probably no way to define "source"; in non-trivial cases there's
always some judgement involved. But if you find a clearer wording for
Policy, sure, go ahead.

Ansgar




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 23 Sep 2013 16:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 23 Sep 2013 16:12:04 GMT) Full text and rfc822 format available.

Message #50 received at 688251@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 688251@bugs.debian.org, debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 23 Sep 2013 09:08:55 -0700
Paul Wise <pabs@debian.org> writes:
> On Mon, Sep 23, 2013 at 11:04 AM, Charles Plessy wrote:

>> I paste below the current wording in the Policy 3.9.4.  If you have an
>> improvement to propose, that would be much appreciated !

> The wording doesn't appear confusing to me so I'm not the best person
> to propose wording changes.

The basic problem that we're trying to solve is that nearly every package
in Debian incorporates code from gcc and/or libc into the resulting
binary.  So, currently, Policy says that basically every package in the
archive needs Built-Using.  This obviously isn't what we want to have
happen.

The question is how to make it clear that's not the intent, which requires
figuring out how to separate the other use cases from the gcc and glibc
case.

I suppose one possible approach is to just explicitly exclude the C
library and compiler from the current wording.  (Although I'm not sure
that should be the case for every compiler; for example, do some of the
more complex compilers for languages like Haskell actually need
Built-Using?)

> I would suggest leaving the current wording, monitoring usage of the
> field and filing bugs on any packages that use the field in an
> "improper" way.

We've already had multiple complaints and multiple confused people due to
the current wording.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Sat, 28 Sep 2013 12:48:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Charles Plessy <plessy@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sat, 28 Sep 2013 12:48:04 GMT) Full text and rfc822 format available.

Message #55 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: 688251@bugs.debian.org, debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Sat, 28 Sep 2013 21:45:35 +0900
[Message part 1 (text/plain, inline)]
user debian-policy@packages.debian.org
tag 688251 - patch
usertags 688251 discussion
thanks

Le Mon, Sep 23, 2013 at 09:08:55AM -0700, Russ Allbery a écrit :
> 
> The basic problem that we're trying to solve is that nearly every package
> in Debian incorporates code from gcc and/or libc into the resulting
> binary.  So, currently, Policy says that basically every package in the
> archive needs Built-Using.  This obviously isn't what we want to have
> happen.
> 
> The question is how to make it clear that's not the intent, which requires
> figuring out how to separate the other use cases from the gcc and glibc
> case.
> 
> I suppose one possible approach is to just explicitly exclude the C
> library and compiler from the current wording.  (Although I'm not sure
> that should be the case for every compiler; for example, do some of the
> more complex compilers for languages like Haskell actually need
> Built-Using?)

Hi Russ and everybody,

would the attached patch be accurate for the C compiler ?

For the C library, since I do not understand well where and when some code
is added to the binary, I have a hard time writing something clear.

If my patch is a good start, could somebody improve it ?

Have a nice week-end,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan
[0001-Policy-Built-Using-is-not-necessary-for-runtime-exce.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Sun, 06 Oct 2013 08:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Charles Plessy <plessy@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 06 Oct 2013 08:33:04 GMT) Full text and rfc822 format available.

Message #60 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: 688251@bugs.debian.org, debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Sun, 6 Oct 2013 17:30:12 +0900
[Message part 1 (text/plain, inline)]
Thanks everybody for your contributions to clarify the uses case of the
Built-Using field.

The attached patch is a third attempt, which underlines that the Built-Using
field is particularly useful when a given package, contributing contents
included in another package, can not be replaced by a later version.  It also
explains that the Debian archive uses the Built-Using field to retain source
packages.

What do you think about it ?

Have a nice Sunday,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan
[0001-Policy-Clarify-the-purpose-of-the-Built-Using-field.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#688251; Package debian-policy. (Mon, 14 Oct 2013 05:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Charles Plessy <plessy@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 14 Oct 2013 05:42:05 GMT) Full text and rfc822 format available.

Message #65 received at 688251@bugs.debian.org (full text, mbox):

From: Charles Plessy <plessy@debian.org>
To: 688251@bugs.debian.org
Cc: debian-devel@lists.debian.org, ftpmaster@debian.org
Subject: Re: Bug#688251: #688251: Built-Using description too aggressive
Date: Mon, 14 Oct 2013 14:39:15 +0900
Le Sun, Oct 06, 2013 at 05:30:12PM +0900, Charles Plessy a écrit :
> 
> The attached patch is a third attempt, which underlines that the Built-Using
> field is particularly useful when a given package, contributing contents
> included in another package, can not be replaced by a later version.  It also
> explains that the Debian archive uses the Built-Using field to retain source
> packages.
> 
> What do you think about it ?

Hello everybody,

I intend to upload the update 3.9.5 of the Policy before the end of October, so
if there is no conclusion about Built-Using, there will be no clarification in
this round.

Have a nice day,

-- 
Charles Plessy
Tsurumi, Kanagawa, Japan



Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 21:54:35 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.